Index: uspace/app/usbinfo/list.c
===================================================================
--- uspace/app/usbinfo/list.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/app/usbinfo/list.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -44,48 +44,86 @@
 #include <devman.h>
 #include <loc.h>
-#include <usb/dev/hub.h>
-#include <usb/hc.h>
+#include <usb_iface.h>
 
 #include "usbinfo.h"
 
-#define MAX_USB_ADDRESS USB11_ADDRESS_MAX
 #define MAX_PATH_LENGTH 1024
 
-static void print_found_hc(service_id_t sid, const char *path)
+static void print_usb_device(devman_handle_t handle)
 {
-	printf("Bus %" PRIun ": %s\n", sid, path);
-}
-static void print_found_dev(usb_address_t addr, const char *path)
-{
-	printf("  Device %02d: %s\n", addr, path);
+	char path[MAX_PATH_LENGTH];
+	int rc = devman_fun_get_path(handle, path, MAX_PATH_LENGTH);
+	if (rc != EOK) {
+		printf(NAME "Failed to get path for device %"PRIun"\n", handle);
+		return;
+	}
+	printf("\tDevice %" PRIun ": %s\n", handle, path);
 }
 
-static void print_hc_devices(devman_handle_t hc_handle)
+static void print_usb_bus(service_id_t svc)
 {
-	int rc;
-	usb_hc_connection_t conn;
-
-	usb_hc_connection_initialize(&conn, hc_handle);
-	rc = usb_hc_connection_open(&conn);
+	devman_handle_t hc_handle = 0;
+	int rc = devman_fun_sid_to_handle(svc, &hc_handle);
 	if (rc != EOK) {
-		printf(NAME ": failed to connect to HC: %s.\n",
-		    str_error(rc));
+		printf(NAME ": Error resolving handle of HC with SID %"
+		    PRIun ", skipping.\n", svc);
 		return;
 	}
-	usb_address_t addr;
-	for (addr = 1; addr < MAX_USB_ADDRESS; addr++) {
-		devman_handle_t dev_handle;
-		rc = usb_hc_get_handle_by_address(&conn, addr, &dev_handle);
-		if (rc != EOK) {
-			continue;
-		}
-		char path[MAX_PATH_LENGTH];
-		rc = devman_fun_get_path(dev_handle, path, MAX_PATH_LENGTH);
-		if (rc != EOK) {
-			continue;
-		}
-		print_found_dev(addr, path);
+
+	char path[MAX_PATH_LENGTH];
+	rc = devman_fun_get_path(hc_handle, path, sizeof(path));
+	if (rc != EOK) {
+		printf(NAME ": Error resolving path of HC with SID %"
+		    PRIun ", skipping.\n", svc);
+		return;
 	}
-	usb_hc_connection_close(&conn);
+	printf("Bus %" PRIun ": %s\n", svc, path);
+
+	/* Construct device's path.
+	 * That's "hc function path" - ( '/' + "hc function name" ) */
+	// TODO replace this with something sane
+
+	/* Get function name */
+	char name[10];
+	rc = devman_fun_get_name(hc_handle, name, sizeof(name));
+	if (rc != EOK) {
+		printf(NAME ": Error resolving name of HC with SID %"
+		    PRIun ", skipping.\n", svc);
+		return;
+	}
+
+	/* Get handle of parent device */
+	devman_handle_t fh;
+	path[str_size(path) - str_size(name) - 1] = '\0';
+	rc = devman_fun_get_handle(path, &fh, IPC_FLAG_BLOCKING);
+	if (rc != EOK) {
+		printf(NAME ": Error resolving parent handle of HC with"
+		    " SID %" PRIun ", skipping.\n", svc);
+		return;
+	}
+
+	/* Get child handle */
+	devman_handle_t dh;
+	rc = devman_fun_get_child(fh, &dh);
+	if (rc != EOK) {
+		printf(NAME ": Error resolving parent handle of HC with"
+		    " SID %" PRIun ", skipping.\n", svc);
+		return;
+	}
+	
+	devman_handle_t *fhs = 0;
+	size_t count;
+	rc = devman_dev_get_functions(dh, &fhs, &count);
+	if (rc != EOK) {
+		printf(NAME ": Error siblings of HC with"
+		    " SID %" PRIun ", skipping.\n", svc);
+		return;
+	}
+
+	for (size_t i = 0; i < count; ++i) {
+		if (fhs[i] != hc_handle)
+			print_usb_device(fhs[i]);
+	}
+	free(fhs);
 }
 
@@ -95,5 +133,4 @@
 	service_id_t *svcs;
 	size_t count;
-	size_t i;
 	int rc;
 
@@ -111,21 +148,6 @@
 	}
 
-	for (i = 0; i < count; i++) {
-		devman_handle_t hc_handle = 0;
-		int rc = usb_ddf_get_hc_handle_by_sid(svcs[i], &hc_handle);
-		if (rc != EOK) {
-			printf(NAME ": Error resolving handle of HC with SID %"
-			    PRIun ", skipping.\n", svcs[i]);
-			continue;
-		}
-		char path[MAX_PATH_LENGTH];
-		rc = devman_fun_get_path(hc_handle, path, MAX_PATH_LENGTH);
-		if (rc != EOK) {
-			printf(NAME ": Error resolving path of HC with SID %"
-			    PRIun ", skipping.\n", svcs[i]);
-			continue;
-		}
-		print_found_hc(svcs[i], path);
-		print_hc_devices(hc_handle);
+	for (unsigned i = 0; i < count; ++i) {
+		print_usb_bus(svcs[i]);
 	}
 
Index: uspace/app/usbinfo/main.c
===================================================================
--- uspace/app/usbinfo/main.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/app/usbinfo/main.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -43,5 +43,4 @@
 #include <devman.h>
 #include <loc.h>
-#include <usb/hc.h>
 #include <usb/dev.h>
 #include <usb/dev/pipes.h>
@@ -198,8 +197,6 @@
 
 		/* The initialization is here only to make compiler happy. */
-		devman_handle_t hc_handle = 0;
-		usb_address_t dev_addr = 0;
-		int rc = usb_resolve_device_handle(devpath,
-		    &hc_handle, &dev_addr, NULL);
+		devman_handle_t handle = 0;
+		int rc = usb_resolve_device_handle(devpath, &handle);
 		if (rc != EOK) {
 			fprintf(stderr, NAME ": device `%s' not found "
@@ -209,7 +206,7 @@
 		}
 
-		usbinfo_device_t *dev = prepare_device(devpath,
-		    hc_handle, dev_addr);
-		if (dev == NULL) {
+		usb_device_t *usb_dev = usb_device_create(handle);
+
+		if (usb_dev == NULL) {
 			continue;
 		}
@@ -221,11 +218,10 @@
 		while (actions[action].opt != 0) {
 			if (actions[action].active) {
-				actions[action].action(dev);
+				actions[action].action(usb_dev);
 			}
 			action++;
 		}
 
-		/* Destroy the control pipe (close the session etc.). */
-		destroy_device(dev);
+		usb_device_destroy(usb_dev);
 	}
 
Index: uspace/app/usbinfo/usbinfo.h
===================================================================
--- uspace/app/usbinfo/usbinfo.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/app/usbinfo/usbinfo.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -38,21 +38,11 @@
 #include <usb/usb.h>
 #include <usb/descriptor.h>
-#include <usb/dev/pipes.h>
-#include <usb/debug.h>
+#include <usb/dev/device.h>
 #include <usb/dev/dp.h>
 #include <ipc/devman.h>
 
 typedef struct {
-	usb_hc_connection_t hc_conn;
-	usb_device_connection_t wire;
-	usb_pipe_t ctrl_pipe;
-	usb_standard_device_descriptor_t device_descriptor;
-	uint8_t *full_configuration_descriptor;
-	size_t full_configuration_descriptor_size;
-} usbinfo_device_t;
-
-typedef struct {
 	int opt;
-	void (*action)(usbinfo_device_t *dev);
+	void (*action)(usb_device_t *usb_dev);
 	bool active;
 } usbinfo_action_t;
@@ -72,7 +62,4 @@
 }
 
-usbinfo_device_t *prepare_device(const char *, devman_handle_t, usb_address_t);
-void destroy_device(usbinfo_device_t *);
-
 typedef void (*dump_descriptor_in_tree_t)(const uint8_t *, size_t, void *);
 void browse_descriptor_tree(uint8_t *, size_t, usb_dp_descriptor_nesting_t *,
@@ -81,13 +68,12 @@
 void list(void);
 
-void dump_short_device_identification(usbinfo_device_t *);
-void dump_device_match_ids(usbinfo_device_t *);
-void dump_descriptor_tree_brief(usbinfo_device_t *);
-void dump_descriptor_tree_full(usbinfo_device_t *);
-void dump_strings(usbinfo_device_t *);
-void dump_status(usbinfo_device_t *);
-void dump_hidreport_raw(usbinfo_device_t *);
-void dump_hidreport_usages(usbinfo_device_t *);
-
+void dump_short_device_identification(usb_device_t *);
+void dump_device_match_ids(usb_device_t *);
+void dump_descriptor_tree_brief(usb_device_t *);
+void dump_descriptor_tree_full(usb_device_t *);
+void dump_strings(usb_device_t *);
+void dump_status(usb_device_t *);
+void dump_hidreport_raw(usb_device_t *);
+void dump_hidreport_usages(usb_device_t *);
 
 #endif
Index: uspace/app/vuhid/device.c
===================================================================
--- uspace/app/vuhid/device.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/app/vuhid/device.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -60,5 +60,5 @@
 static int on_data_to_device(usbvirt_device_t *dev,
     usb_endpoint_t ep, usb_transfer_type_t tr_type,
-    void *data, size_t data_size)
+    const void *data, size_t data_size)
 {
 	vuhid_data_t *vuhid = dev->device_data;
@@ -254,7 +254,6 @@
 
 	/* Extend existing extra descriptors with these ones. */
-	usbvirt_device_configuration_extras_t *extra_descriptors
-	    = dev->descriptors->configuration->extra;
-	extra_descriptors = realloc(extra_descriptors,
+	usbvirt_device_configuration_extras_t *extra_descriptors;
+	extra_descriptors = realloc(dev->descriptors->configuration->extra,
 	    sizeof(usbvirt_device_configuration_extras_t)
 	    * (dev->descriptors->configuration->extra_count + descr_count));
Index: uspace/app/vuhid/hids/bootkbd.c
===================================================================
--- uspace/app/vuhid/hids/bootkbd.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/app/vuhid/hids/bootkbd.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -102,5 +102,5 @@
 
 static int on_data_out(vuhid_interface_t *iface,
-    void *buffer, size_t buffer_size)
+    const void *buffer, size_t buffer_size)
 {
 	if (buffer_size == 0) {
Index: uspace/app/vuhid/main.c
===================================================================
--- uspace/app/vuhid/main.c	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/app/vuhid/main.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -40,4 +40,5 @@
 #include <errno.h>
 #include <str_error.h>
+#include <getopt.h>
 
 #include <usb/usb.h>
@@ -52,26 +53,19 @@
 #include "stdreq.h"
 
+#define DEFAULT_CONTROLLER   "/virt/usbhc/ctl"
+
 static usbvirt_control_request_handler_t endpoint_zero_handlers[] = {
 	{
-		.req_direction = USB_DIRECTION_IN,
-		.req_type = USB_REQUEST_TYPE_STANDARD,
-		.req_recipient = USB_REQUEST_RECIPIENT_INTERFACE,
-		.request = USB_DEVREQ_GET_DESCRIPTOR,
+		STD_REQ_IN(USB_REQUEST_RECIPIENT_INTERFACE, USB_DEVREQ_GET_DESCRIPTOR),
 		.name = "Get_Descriptor",
 		.callback = req_get_descriptor
 	},
 	{
-		.req_direction = USB_DIRECTION_OUT,
-		.req_recipient = USB_REQUEST_RECIPIENT_INTERFACE,
-		.req_type = USB_REQUEST_TYPE_CLASS,
-		.request = USB_HIDREQ_SET_PROTOCOL,
+		CLASS_REQ_OUT(USB_REQUEST_RECIPIENT_INTERFACE, USB_HIDREQ_SET_PROTOCOL),
 		.name = "Set_Protocol",
 		.callback = req_set_protocol
 	},
 	{
-		.req_direction = USB_DIRECTION_OUT,
-		.req_recipient = USB_REQUEST_RECIPIENT_INTERFACE,
-		.req_type = USB_REQUEST_TYPE_CLASS,
-		.request = USB_HIDREQ_SET_REPORT,
+		CLASS_REQ_OUT(USB_REQUEST_RECIPIENT_INTERFACE, USB_HIDREQ_SET_REPORT),
 		.name = "Set_Report",
 		.callback = req_set_report
@@ -151,7 +145,68 @@
 
 
+static struct option long_options[] = {
+	{"help", optional_argument, NULL, 'h'},
+	{"controller", required_argument, NULL, 'c' },
+	{"list", no_argument, NULL, 'l' },
+	{0, 0, NULL, 0}
+};
+static const char *short_options = "hc:l";
+
+static void print_help(const char* name, const char* module)
+{
+	if (module == NULL) {
+		/* Default help */
+		printf("Usage: %s [options] device.\n", name);
+		printf("\t-h, --help [device]\n");
+		printf("\t\to With no argument print this help and exit.\n");
+		printf("\t\to With argument print device specific help and exit.\n");
+		printf("\t-l, --list \n\t\tPrint list of available devices.\n");
+		printf("\t-c, --controller \n\t\t"
+		    "Use provided virtual hc instead of default (%s)\n",
+		    DEFAULT_CONTROLLER);
+		return;
+	}
+	printf("HELP for module %s\n", module);
+}
+
+static void print_list(void)
+{
+	printf("Available devices:\n");
+	for (vuhid_interface_t **i = available_hid_interfaces; *i != NULL; ++i)
+	{
+		printf("\t`%s'\t%s\n", (*i)->id, (*i)->name);
+	}
+
+}
+
+static const char *controller = DEFAULT_CONTROLLER;
+
 int main(int argc, char * argv[])
 {
-	int rc;
+
+	if (argc == 1) {
+		print_help(*argv, NULL);
+		return 0;
+	}
+
+	int opt = 0;
+	while ((opt = getopt_long(argc, argv, short_options, long_options, NULL)) > 0) {
+		switch (opt)
+		{
+		case 'h':
+			print_help(*argv, optarg);
+			return 0;
+		case 'c':
+			controller = optarg;
+			break;
+		case 'l':
+			print_list();
+			return 0;
+		case -1:
+		default:
+			break;
+		}
+	}
+
 
 	log_init("vuhid");
@@ -161,7 +216,6 @@
 
 	/* Determine which interfaces to initialize. */
-	int i;
-	for (i = 1; i < argc; i++) {
-		rc = add_interface_by_id(available_hid_interfaces, argv[i],
+	for (int i = optind; i < argc; i++) {
+		int rc = add_interface_by_id(available_hid_interfaces, argv[i],
 		    &hid_dev);
 		if (rc != EOK) {
@@ -173,5 +227,5 @@
 	}
 
-	for (i = 0; i < (int) hid_dev.descriptors->configuration->extra_count; i++) {
+	for (int i = 0; i < (int) hid_dev.descriptors->configuration->extra_count; i++) {
 		usb_log_debug("Found extra descriptor: %s.\n",
 		    usb_debug_str_buffer(
@@ -181,12 +235,12 @@
 	}
 
-	rc = usbvirt_device_plug(&hid_dev, "/virt/usbhc/hc");
+	const int rc = usbvirt_device_plug(&hid_dev, controller);
 	if (rc != EOK) {
-		printf("Unable to start communication with VHCD: %s.\n",
-		    str_error(rc));
+		printf("Unable to start communication with VHCD `%s': %s.\n",
+		    controller, str_error(rc));
 		return rc;
 	}
 	
-	printf("Connected to VHCD...\n");
+	printf("Connected to VHCD `%s'...\n", controller);
 
 	wait_for_interfaces_death(&hid_dev);
Index: uspace/app/vuhid/virthid.h
===================================================================
--- uspace/app/vuhid/virthid.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/app/vuhid/virthid.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -71,5 +71,5 @@
 
 	int (*on_data_in)(vuhid_interface_t *, void *, size_t, size_t *);
-	int (*on_data_out)(vuhid_interface_t *, void *, size_t);
+	int (*on_data_out)(vuhid_interface_t *, const void *, size_t);
 	void (*live)(vuhid_interface_t *);
 
Index: uspace/doc/doxygroups.h
===================================================================
--- uspace/doc/doxygroups.h	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/doc/doxygroups.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -285,16 +285,4 @@
 	 */
 
-		/**
-		 * @defgroup drvusbuhcirh UHCI root hub driver
-		 * @ingroup drvusbuhci
-		 * @brief Driver for UHCI complaint root hub.
-		 */
-
-		/**
-		 * @defgroup drvusbuhcihc UHCI host controller driver
-		 * @ingroup drvusbuhci
-		 * @brief Driver for UHCI complaint USB host controller.
-		 */
-
 	/**
 	 * @defgroup drvusbohci OHCI driver
Index: uspace/drv/bus/usb/ehci/Makefile
===================================================================
--- uspace/drv/bus/usb/ehci/Makefile	(revision facc34d65ca01ca5069b1a462b8fade5dccd99b6)
+++ uspace/drv/bus/usb/ehci/Makefile	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -31,4 +31,5 @@
 LIBS = \
 	$(LIBUSBHOST_PREFIX)/libusbhost.a \
+	$(LIBUSBVIRT_PREFIX)/libusbvirt.a \
 	$(LIBUSB_PREFIX)/libusb.a \
 	$(LIBDRV_PREFIX)/libdrv.a
@@ -36,5 +37,7 @@
 EXTRA_CFLAGS += \
 	-I$(LIBUSB_PREFIX)/include \
+	-I$(LIBUSBDEV_PREFIX)/include \
 	-I$(LIBUSBHOST_PREFIX)/include \
+	-I$(LIBUSBVIRT_PREFIX)/include \
 	-I$(LIBDRV_PREFIX)/include
 
@@ -42,4 +45,6 @@
 
 SOURCES = \
+	ehci_rh.c \
+	hc.c \
 	main.c \
 	res.c
Index: uspace/drv/bus/usb/ehci/ehci_regs.h
===================================================================
--- uspace/drv/bus/usb/ehci/ehci_regs.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
+++ uspace/drv/bus/usb/ehci/ehci_regs.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -0,0 +1,172 @@
+/*
+ * Copyright (c) 2013 Jan Vesely
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup drvusbehci
+ * @{
+ */
+/** @file
+ * @brief EHCI host controller register structure
+ */
+#ifndef DRV_EHCI_EHCI_REGS_H
+#define DRV_EHCI_EHCI_REGS_H
+#include <sys/types.h>
+#include <byteorder.h>
+#include <macros.h>
+#include <ddi.h>
+
+#define EHCI_WR(reg, val) pio_write_32(&(reg), host2uint32_t_le(val))
+#define EHCI_RD(reg) uint32_t_le2host(pio_read_32(&(reg)))
+#define EHCI_RD8(reg) pio_read_8(&(reg))
+//#define EHCI_SET(reg, val) reg |= host2uint32_t_le(val)
+//#define EHCI_CLR(reg, val) reg &= host2uint32_t_le(~val)
+
+/** EHCI memory mapped capability registers structure */
+typedef struct ehci_cap_regs {
+	const ioport8_t caplength;
+	PADD8;
+	const ioport16_t hciversion;
+	const ioport32_t hcsparams;
+#define EHCI_CAPS_HCS_DEBUG_PORT_MASK   0xf
+#define EHCI_CAPS_HCS_DEBUG_PORT_SHIFT  (1 << 20)
+#define EHCI_CAPS_HCS_INDICATORS_FLAG   (1 << 16)
+#define EHCI_CAPS_HCS_N_CC_MASK         0xf
+#define EHCI_CAPS_HCS_N_CC_SHIFT        12
+#define EHCI_CAPS_HCS_N_PCC_MASK        0xf
+#define EHCI_CAPS_HCS_N_PCC_SHIFT       8
+#define EHCI_CAPS_HCS_ROUTING_FLAG      (1 << 7)
+#define EHCI_CAPS_HCS_PPC_FLAG          (1 << 4)
+#define EHCI_CAPS_HCS_N_PORTS_MASK      0xf
+#define EHCI_CAPS_HCS_N_PORTS_SHIFT     0
+
+	const ioport32_t hccparams;
+#define EHCI_CAPS_HCC_EECP_MASK           0xff
+#define EHCI_CAPS_HCC_EECP_SHIFT          8
+#define EHCI_CAPS_HCC_ISO_THRESHOLD_MASK  0xf
+#define EHCI_CAPS_HCC_ISO_THRESHOLD_SHIFT 4
+#define EHCI_CAPS_HCC_ASYNC_PART_FLAG     (1 << 2)
+#define EHCI_CAPS_HCC_PROG_FRAME_FLAG     (1 << 1)
+#define EHCI_CAPS_HCC_64_FLAG             (1 << 0)
+	ioport8_t hcsp_portoute[8];
+
+} ehci_caps_regs_t;
+
+
+/** EHCI memory mapped operational registers structure */
+typedef struct ehci_regs {
+	ioport32_t usbcmd;
+#define USB_CMD_INT_THRESHOLD_MASK     0xff
+#define USB_CMD_INT_THRESHOLD_SHIFT    16
+#define USB_CMD_PARK_MODE_FLAG         (1 << 11)
+#define USB_CMD_PARK_COUNT_MASK        0x3
+#define USB_CMD_PARK_COUNT_SHIFT       8
+#define USB_CMD_LIGHT_RESET            (1 << 7)
+#define USB_CMD_IRQ_ASYNC_DOORBELL     (1 << 6)
+#define USB_CMD_ASYNC_SCHEDULE_FLAG    (1 << 5)
+#define USB_CMD_PERIODIC_SCHEDULE_FLAG (1 << 4)
+#define USB_CMD_FRAME_LIST_SIZE_MASK   0x3
+#define USB_CMD_FRAME_LIST_SIZE_SHIFT  2
+#define USB_CMD_FRAME_LIST_SIZE_1024   0x0
+#define USB_CMD_FRAME_LIST_SIZE_512    0x1
+#define USB_CMD_FRAME_LIST_SIZE_256    0x2
+#define USB_CMD_HC_RESET_FLAG          (1 << 1)
+#define USB_CMD_RUN_FLAG               (1 << 0)
+
+	ioport32_t usbsts;
+#define USB_STS_ASYNC_SCHED_FLAG         (1 << 15)
+#define USB_STS_PERIODIC_SCHED_FLAG      (1 << 14)
+#define USB_STS_RECLAMATION_FLAG         (1 << 13)
+#define USB_STS_HC_HALTED_FLAG           (1 << 12)
+#define USB_STS_IRQ_ASYNC_ADVANCE_FLAG   (1 <<  5)
+#define USB_STS_HOST_ERROR_FLAG          (1 <<  4)
+#define USB_STS_FRAME_ROLLOVER_FLAG      (1 <<  3)
+#define USB_STS_PORT_CHANGE_FLAG         (1 <<  2)
+#define USB_STS_ERR_IRQ_FLAG             (1 <<  1)
+#define USB_STS_IRQ_FLAG                 (1 <<  0)
+
+	ioport32_t usbintr;
+#define USB_INTR_ASYNC_ADVANCE_FLAG   (1 << 5)
+#define USB_INTR_HOST_ERR_FLAG        (1 << 4)
+#define USB_INTR_FRAME_ROLLOVER_FLAG  (1 << 3)
+#define USB_INTR_PORT_CHANGE_FLAG     (1 << 2)
+#define USB_INTR_ERR_IRQ_FLAG         (1 << 1)
+#define USB_INTR_IRQ_FLAG             (1 << 0)
+
+	ioport32_t frindex;
+#define USB_FRINDEX_MASK   0xfff
+
+	ioport32_t ctrldssegment;
+	ioport32_t periodiclistbase;
+#define USB_PERIODIC_LIST_BASE_MASK   0xfffff000
+
+	ioport32_t asynclistaddr;
+#define USB_ASYNCLIST_MASK   0xfffffff0
+
+	PADD32[9];
+
+	ioport32_t configflag;
+#define USB_CONFIG_FLAG_FLAG   (1 << 0)
+
+	ioport32_t portsc[];
+#define USB_PORTSC_WKOC_E_FLAG       (1 << 22)
+#define USB_PORTSC_WKDSCNNT_E_FLAG   (1 << 21)
+#define USB_PORTSC_WKCNNT_E_FLAG     (1 << 20)
+#define USB_PORTSC_PORT_TEST_MASK    0xf
+#define USB_PORTSC_PORT_TEST_SHIFT   16
+#define USB_PORTSC_NO_TEST           0x0
+#define USB_PORTSC_TEST_J_STATE      0x1
+#define USB_PORTSC_TEST_K_STATE      0x2
+#define USB_PORTSC_TEST_SE0_NAK      0x3
+#define USB_PORTSC_TEST_PACKET       0x4
+#define USB_PORTSC_TEST_FORCE_ENABLE 0x5
+#define USB_PORTSC_INDICATOR_MASK    0x3
+#define USB_PORTSC_INDICATOR_SHIFT   14
+#define USB_PORTSC_INDICATOR_OFF     0x0
+#define USB_PORTSC_INDICATOR_AMBER   0x1
+#define USB_PORTSC_INDICATOR_GREEN   0x2
+#define USB_PORTSC_PORT_OWNER_FLAG   (1 << 13)
+#define USB_PORTSC_PORT_POWER_FLAG   (1 << 12)
+#define USB_PORTSC_LINE_STATUS_MASK  0x3
+#define USB_PORTSC_LINE_STATUS_SHIFT 10
+#define USB_PORTSC_LINE_STATUS_SE0   0x0
+#define USB_PORTSC_LINE_STATUS_K     0x1
+#define USB_PORTSC_LINE_STATUS_J     0x2
+#define USB_PORTSC_PORT_RESET_FLAG   (1 << 8)
+#define USB_PORTSC_SUSPEND_FLAG      (1 << 7)
+#define USB_PORTSC_RESUME_FLAG       (1 << 6)
+#define USB_PORTSC_OC_CHANGE_FLAG    (1 << 5)
+#define USB_PORTSC_OC_ACTIVE_FLAG    (1 << 4)
+#define USB_PORTSC_EN_CHANGE_FLAG    (1 << 3)
+#define USB_PORTSC_ENABLED_FLAG      (1 << 2)
+#define USB_PORTSC_CONNECT_CH_FLAG   (1 << 1)
+#define USB_PORTSC_CONNECT_FLAG      (1 << 0)
+} ehci_regs_t;
+
+#endif
+/**
+ * @}
+ */
+
